/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.entity.Stimmen;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class StimmenExtendedDAO extends AbstractStimmenDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountByErgebnisAndGruppeNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT COUNT(o) FROM Stimmen o WHERE o.ergebnis=?1 AND o.gruppe=?2<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountByErgebnisAndGruppe( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmen.findByCountByErgebnisAndGruppe" ,  ergebnis ,  gruppe  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountByErgebnisAndGruppe(): Miss");
        }

        cache.put(key, super.findByCountByErgebnisAndGruppe( ergebnis ,  gruppe  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountByErgebnisAndGruppe(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountByErgebnisAndGruppe( ergebnis ,  gruppe  );
}
/**
* Name: CountStimmenByWahlAndErgebnisartNoFlush<br>
* Beschreibung: Dient der Bestimmung, ob für eine Ergebnisart bereits Stimmen vorliegen.<br>
* EJBQL: SELECT count(s) FROM Stimmen s WHERE s.ergebnis.wahl = ?1 AND s.ergebnis.ergebnisart=?2<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountStimmenByWahlAndErgebnisart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmen.findByCountStimmenByWahlAndErgebnisart" ,  wahl ,  ergebnisart  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountStimmenByWahlAndErgebnisart(): Miss");
        }

        cache.put(key, super.findByCountStimmenByWahlAndErgebnisart( wahl ,  ergebnisart  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountStimmenByWahlAndErgebnisart(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountStimmenByWahlAndErgebnisart( wahl ,  ergebnisart  );
}
/**
* Name: ErgebnisCountAnzahlStimmenNoFlush<br>
* Beschreibung: Zählt die Anzahl der Stimmen für ein Ergebnis. Wird als Pre-Condition-Check verwendet, um zu überprüfen, ob für ein Ergebnis bereits Stimmen vorliegen.<br>
* EJBQL: SELECT COUNT(s) FROM Stimmen s WHERE s.ergebnis = ?1<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByErgebnisCountAnzahlStimmen( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmen.findByErgebnisCountAnzahlStimmen" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebnisCountAnzahlStimmen(): Miss");
        }

        cache.put(key, super.findByErgebnisCountAnzahlStimmen( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebnisCountAnzahlStimmen(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByErgebnisCountAnzahlStimmen( ergebnis  );
}
/**
* Name: StimmenAnzahlByStimmartUndGruppeAndCountNoFlush<br>
* Beschreibung: Findet die Anzahl der Stimmen pro Gruppe in den angegebenen Gebieten (für die Stimmen zu einem Ergebnis). Wir für die grafische Darstellung von Stimmen benötigt.<br>
* EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe(s.gruppe, s.stimmenart, SUM(s.anzahl)) FROM Stimmen s WHERE s.ergebnis=?1 AND s.gebiet IN (?2) GROUP BY s.gruppe, s.stimmenart<br>
* SQL: <br>
*/
@Override
public java.util.List<de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe> findByStimmenAnzahlByStimmartUndGruppeAndCount( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmen.findByStimmenAnzahlByStimmartUndGruppeAndCount" ,  ergebnis ,  gebiete  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByStimmenAnzahlByStimmartUndGruppeAndCount(): Miss");
        }

        cache.put(key, super.findByStimmenAnzahlByStimmartUndGruppeAndCount( ergebnis ,  gebiete  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByStimmenAnzahlByStimmartUndGruppeAndCount(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe>) cache.lookup(key));
    }

    return super.findByStimmenAnzahlByStimmartUndGruppeAndCount( ergebnis ,  gebiete  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
